--- cvs/wine/windows/class.c	Mon Jul 30 06:46:34 2001
+++ wine/windows/class.c	Fri Aug 10 04:05:54 2001
@@ -469,7 +469,12 @@
     int iSmIconWidth, iSmIconHeight;
     CLASS *classPtr;
 
-    if (!(atom = GlobalAddAtomA( wc->lpszClassName ))) return 0;
+    if (!wc->hInstance)
+	atom = GlobalAddAtomA( wc->lpszClassName );
+    else
+	atom = AddAtomA( wc->lpszClassName );
+
+    if (!atom) return 0;
 
     if (!(classPtr = CLASS_RegisterClass( atom, wc->hInstance, wc->style,
                                           wc->cbClsExtra, wc->cbWndExtra )))
@@ -510,7 +515,12 @@
     int iSmIconWidth, iSmIconHeight;
     CLASS *classPtr;
 
-    if (!(atom = GlobalAddAtomW( wc->lpszClassName ))) return 0;
+    if (!wc->hInstance)
+	atom = GlobalAddAtomW( wc->lpszClassName );
+    else
+	atom = AddAtomW( wc->lpszClassName );
+
+    if (!atom) return 0;
 
     if (!(classPtr = CLASS_RegisterClass( atom, wc->hInstance, wc->style,
                                           wc->cbClsExtra, wc->cbWndExtra )))
